=== common/include/nova-simd/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (nova-simd)

enable_testing()

add_subdirectory (benchmarks)
add_subdirectory (testsuite)
