=== debian/changelog ===
supercollider (1:3.4.5-1wheezy1) testing; urgency=low

  [ Dan Stowell ]
  * Update rules to set DEB_SRCDIR. Closes #674386

  [ Felipe Sateler ]
  * Build with gcc 4.6 to avoid an internal compiler error with 4.7

 -- Felipe Sateler <fsateler@debian.org>  Wed, 15 Aug 2012 18:20:51 -0400

supercollider (1:3.4.5-1) unstable; urgency=low

  [ Dan Stowell ]
  * Imported Upstream version 3.4.5
  * remove debian patches 11 & 12, upstreamed

 -- Dan Stowell <danstowell@users.sourceforge.net>  Sun, 15 Jan 2012 15:48:04 +0000

supercollider (1:3.4.4-3) unstable; urgency=low

  * Patch from Mathieu Trudel-Lapierre to fix build under stricter linking.
    Closes: #648782

 -- Dan Stowell <danstowell@users.sourceforge.net>  Tue, 15 Nov 2011 09:54:00 +0000
